<template>
  <div class="box-main shadow-2">
    <div class="row q-px-md justify-between q-pt-md">
      <div class="text-h6">{{ data.sensorName }}</div>
      <div class="row">
        <div class="q-mr-md cursor-pointer">
          <q-icon
            name="fa-solid fa-trash-can"
            color="secondary"
            @click="deleteSensor()"
          />
        </div>
        <div class="q-mr-md cursor-pointer">
          <q-icon
            name="fa-solid fa-pen-to-square"
            color="secondary"
            @click="editSensor(data.sensorID, data.sensorName, data.sensorType)"
          />
        </div>
        <div class="q-mr-md cursor-pointer">
          <q-icon
            name="fa-regular fa-image"
            color="secondary"
            @click="openPictureDia()"
          />
        </div>
        <div>
          <div
            class="onlineBtn"
            v-if="data.online"
            @click="setStatus(0, data.sensorID)"
          >
            online
          </div>
          <div class="offlineBtn" v-else @click="setStatus(1, data.sensorID)">
            offline
          </div>
        </div>
      </div>
    </div>
    <div class="row q-px-md justify-between">
      <div>{{ data.sensorType }}</div>
      <div class="cursor-pointer"><u>Add new axis</u></div>
    </div>
    <div class="picbox">
      {{ data.picture ? data.picture : "No picture" }}
    </div>
    <div class="row q-px-md axisbar">
      <div style="width: 8%" align="center">Axis</div>
      <div class="col" align="center">Unit</div>
      <div style="width: 12%" align="center">factor</div>
      <div style="width: 15%" align="center">min limit</div>
      <div style="width: 15%" align="center">max limit</div>
      <div style="width: 12%" align="center">column</div>
      <div style="width: 10%" align="center">edit</div>
      <div style="width: 12%" align="center">delete</div>
    </div>
    <div
      class="row q-px-md contentbar"
      v-for="(item2, index2) in data.sensor"
      :key="index2"
    >
      <div style="width: 8%" align="center">{{ item2.axis }}</div>
      <div class="col" align="center" v-html="item2.unit"></div>
      <div style="width: 12%" align="center">{{ item2.factor }}</div>
      <div style="width: 15%" align="center">
        {{ item2.minLimit == null ? "-" : item2.minLimit }}
      </div>
      <div style="width: 15%" align="center">
        {{ item2.maxLimit == null ? "-" : item2.maxLimit }}
      </div>
      <div style="width: 12%" align="center">{{ item2.column }}</div>
      <div style="width: 10%" align="center">edit</div>
      <div style="width: 12%" align="center">delete</div>
    </div>
    <!-- Dialog รูปภาพ -->
    <q-dialog v-model="picBoxDia" persistent>
      <q-card class="picBoxDia q-py-sm">
        <div class="text-h6 q-px-md">Picture</div>
        <hr />
        <div></div>
      </q-card>
    </q-dialog>
    <!-- Dialog edit sensor -->
    <q-dialog v-model="editSensorDia" persistent>
      <q-card class="editSensor q-pu-sm">
        <div class="text-h6 q-px-md">Edit sensor</div>
        <hr />
        <div class="row">
          <div class="col-3 q-pl-md q-pt-md">name</div>
          <div class="col-8">
            <q-input v-model="sensorData.name" dense />
          </div>
        </div>
        <div class="row">
          <div class="col-3 q-pl-md q-pt-md">type</div>
          <div class="col-8">
            <q-select
              v-model="sensorType"
              :options="sensorTypeOption"
              dense
              emit-value
              map-options
            />
          </div>
        </div>
        <div class="row justify-center q-pt-md">
          <div>
            <q-btn
              label="cancel"
              outline
              class="btn"
              @click="closeEditSensor()"
            />
          </div>
          <div style="width: 40px"></div>
          <div>
            <q-btn
              label="Save"
              class="btn"
              color="secondary"
              @click="saveEditSensor()"
            />
          </div>
        </div>
      </q-card>
    </q-dialog>
  </div>
</template>

<script>
import axios from "axios";
export default {
  props: ["data"],
  data() {
    return {
      picBoxDia: false,
      editSensorDia: false,
      sensorName: "",
      sensorType: "",
      sensorTypeOption: [],
      sensorData: {
        id: "",
        name: "",
        type: "",
      },
    };
  },
  methods: {
    async setStatus(status, id) {
      let dataSend = {
        status: status,
        sensorID: id,
      };
      let url = this.apiPath + "setSensorStatus.php";
      let res = await axios.post(url, JSON.stringify(dataSend));
      this.$emit("refreshBox");
    },
    deleteSensor() {
      this.$q
        .dialog({
          title: "Confirm",
          message: "Would you like to delete this sensor?",
          cancel: true,
          persistent: true,
        })
        .onOk(async () => {
          let dataSend = {
            id: this.data.sensorID,
          };
          let url = this.apiPath + "deleteSensor.php";
          let res = await axios.post(url, JSON.stringify(dataSend));
          this.$emit("refeshBox");
        });
    },
    editSensor(id, name, type) {
      this.editSensorDia = true;
      this.sensorData.id = id;
      this.sensorData.name = name;
      this.sensorData.type = type;
    },
    closeEditSensor() {
      this.editSensorDia = false;
    },
    async loadSensorTypeList() {
      this.sensorTypeOption = [];
      let url = this.apiPath + "loadSensorType.php";
      let res = await axios.get(url);
      res.data.forEach((x) => {
        let temp = {
          value: x.id,
          label: x.typeName,
        };
        this.sensorTypeOption.push(temp);
      });
      this.sensorType = this.sensorTypeOption[0].value;
    },
    openPictureDia() {
      console.log("run");

      this.picBoxDia = true;
    },
  },
  mounted() {
    this.loadSensorTypeList();
  },
};
</script>

<style lang="scss" scoped>
.btn {
  width: 150px;
}
.box-main {
  width: 90%;
  height: 420px;
  background-color: white;
  margin: auto;
  margin-bottom: 30px;
}
.onlineBtn {
  background-color: #287377;
  color: white;
  border-radius: 20px;
  width: 60px;
  text-align: center;
  cursor: pointer;
}
.offlineBtn {
  background-color: #ee4873;
  color: white;
  border-radius: 20px;
  width: 60px;
  text-align: center;
  cursor: pointer;
}
.picbox {
  height: 250px;
  width: 90%;
  margin: auto;
  text-align: center;
  line-height: 200px;
}
.axisbar {
  background-color: #287377;
  color: white;
  font-size: 12px;
  padding-top: 5px;
  padding-bottom: 5px;
}
.contentbar {
  font-size: 12px;
}
.picBoxDia {
  widows: 500px;
  min-width: 500px;
  height: 300px;
}
.editSensor {
  widows: 500px;
  min-width: 500px;
  height: 200px;
}
</style>
